<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>SigGen: siggen::ThreadManagerBase Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
  $(document).ready(initResizable);
/* @license-end */</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">SigGen
   &#160;<span id="projectnumber">1.0</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('classsiggen_1_1_thread_manager_base.html','');});
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pub-static-methods">Static Public Member Functions</a> &#124;
<a href="classsiggen_1_1_thread_manager_base-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">siggen::ThreadManagerBase Class Reference<span class="mlabels"><span class="mlabel">abstract</span></span></div>  </div>
</div><!--header-->
<div class="contents">

<p>base for threading manager  
 <a href="classsiggen_1_1_thread_manager_base.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="_thread_manager_base_8h_source.html">ThreadManagerBase.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for siggen::ThreadManagerBase:</div>
<div class="dyncontent">
 <div class="center">
  <img src="classsiggen_1_1_thread_manager_base.png" usemap="#siggen::ThreadManagerBase_map" alt=""/>
  <map id="siggen::ThreadManagerBase_map" name="siggen::ThreadManagerBase_map">
<area href="classsiggen_1_1_thread_manager.html" title="common implementation of a ThreadManager base" alt="siggen::ThreadManager" shape="rect" coords="226,56,442,80"/>
<area href="classsiggen_1_1_thread_manager_eager.html" alt="siggen::ThreadManagerEager" shape="rect" coords="0,112,216,136"/>
<area href="classsiggen_1_1_thread_manager_power_saver.html" title="default thread manager using mutexes and condition variables" alt="siggen::ThreadManagerPowerSaver" shape="rect" coords="226,112,442,136"/>
<area href="classsiggen_1_1_thread_manager_single.html" title="single-thread signature generator" alt="siggen::ThreadManagerSingle" shape="rect" coords="452,112,668,136"/>
  </map>
</div></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a17a355ac0a9a1ed6b0eed23d12a89706"><td class="memItemLeft" align="right" valign="top"><a id="a17a355ac0a9a1ed6b0eed23d12a89706"></a>
virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classsiggen_1_1_thread_manager_base.html#a17a355ac0a9a1ed6b0eed23d12a89706">ProcessToBuffer</a> (std::vector&lt; char &gt; &amp;result)=0</td></tr>
<tr class="memdesc:a17a355ac0a9a1ed6b0eed23d12a89706"><td class="mdescLeft">&#160;</td><td class="mdescRight">processes data assigned to thread manager <br /></td></tr>
<tr class="separator:a17a355ac0a9a1ed6b0eed23d12a89706"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-static-methods"></a>
Static Public Member Functions</h2></td></tr>
<tr class="memitem:acb6c87062d2f75f4ad9d21801950e61e"><td class="memItemLeft" align="right" valign="top">static std::unique_ptr&lt; <a class="el" href="classsiggen_1_1_thread_manager_base.html">ThreadManagerBase</a> &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classsiggen_1_1_thread_manager_base.html#acb6c87062d2f75f4ad9d21801950e61e">Factory</a> (ThreadingPolicy policy, <a class="el" href="structsiggen_1_1_data.html">Data</a> &amp;&amp;data)</td></tr>
<tr class="memdesc:acb6c87062d2f75f4ad9d21801950e61e"><td class="mdescLeft">&#160;</td><td class="mdescRight">creates threading manager according to ThreadingPolicy  <a href="classsiggen_1_1_thread_manager_base.html#acb6c87062d2f75f4ad9d21801950e61e">More...</a><br /></td></tr>
<tr class="separator:acb6c87062d2f75f4ad9d21801950e61e"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>base for threading manager </p>

<p class="definition">Definition at line <a class="el" href="_thread_manager_base_8h_source.html#l00013">13</a> of file <a class="el" href="_thread_manager_base_8h_source.html">ThreadManagerBase.h</a>.</p>
</div><h2 class="groupheader">Member Function Documentation</h2>
<a id="acb6c87062d2f75f4ad9d21801950e61e"></a>
<h2 class="memtitle"><span class="permalink"><a href="#acb6c87062d2f75f4ad9d21801950e61e">&#9670;&nbsp;</a></span>Factory()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">std::unique_ptr&lt; <a class="el" href="classsiggen_1_1_thread_manager_base.html">ThreadManagerBase</a> &gt; siggen::ThreadManagerBase::Factory </td>
          <td>(</td>
          <td class="paramtype">ThreadingPolicy&#160;</td>
          <td class="paramname"><em>policy</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structsiggen_1_1_data.html">Data</a> &amp;&amp;&#160;</td>
          <td class="paramname"><em>data</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>creates threading manager according to ThreadingPolicy </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">policy</td><td>specification of type of threading manager to be created </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">data</td><td>configuration data to be moved to created threading manager</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>threading manager or throws an exception </dd></dl>
<dl class="exception"><dt>Exceptions</dt><dd>
  <table class="exception">
    <tr><td class="paramname">std::runtime_error</td><td></td></tr>
  </table>
  </dd>
</dl>

<p class="definition">Definition at line <a class="el" href="_thread_manager_base_8cpp_source.html#l00011">11</a> of file <a class="el" href="_thread_manager_base_8cpp_source.html">ThreadManagerBase.cpp</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li>/home/x/siggen/lib/include/<a class="el" href="_thread_manager_base_8h_source.html">ThreadManagerBase.h</a></li>
<li>/home/x/siggen/lib/src/<a class="el" href="_thread_manager_base_8cpp_source.html">ThreadManagerBase.cpp</a></li>
</ul>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><b>siggen</b></li><li class="navelem"><a class="el" href="classsiggen_1_1_thread_manager_base.html">ThreadManagerBase</a></li>
    <li class="footer">Generated by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.16 </li>
  </ul>
</div>
</body>
</html>
